{
===============================================================================
  Copyright (©) 2007. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 
  Versión actual: 1.0.0
  Fecha versión actual: 
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit uBizBancaElectronica;

interface

uses
  uDAInterfaces, uDADataTable, uDBSelectionListUtils, schBancaElectronicaClient_Intf;

const
  BIZ_CLIENT_IBIZBANCA = 'Client.IBizBanca';

type
  IBizIBizBanca = interface(IBancaElectronica)
  	['{11CFA381-89E3-4491-B1C4-F270EFB2E6FE}']    
    function EsNuevo : Boolean;
    
  	// Descomentar esto si hay clases detalles
    // procedure SetDetalles(AValue : IBizDetalles);
    // function GetDetalles : IBizDetalles;
    // property Detalles : IBizDetalles read GetDetalles write SetDetalles;  
  end;

  TBizIBizBanca = class(TBancaElectronicaDataTableRules, IBizIBizBanca, ISeleccionable)
  protected
  	FSeleccionableInterface : ISeleccionable;
  	
  	// Descomentar esto si hay clases detalles
    // FDetalles : IBizDetalles;
    // FDetallesLink : TDADataSource;
    // procedure SetDetalles(AValue : IBizDetalles);
    // function GetDetalles : IBizDetalles;

    procedure OnNewRecord(Sender: TDADataTable); override;
  public
    procedure IniciarValoresIBizBancaNuevo;
    function EsNuevo : Boolean;
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

    property SeleccionableInterface : ISeleccionable 
    					read FSeleccionableInterface
    					write FSeleccionableInterface 
    					implements ISeleccionable;
    
  	// Descomentar esto si hay clases detalles
    // property Detalles : IBizDetalles read GetDetalles write SetDetalles;    
  end;

implementation

{ TBizIBizBanca }

uses
  SysUtils, uDataTableUtils;

// Descomentar esto si hay clases detalles
// function TBizIBizBanca.GetDetalles: IBizDetalles;
// begin
//   Result := FDetalles;
// end;

// Descomentar esto si hay clases detalles
// procedure TBizIBizBanca.SetDetalles(AValue: IBizDetalles);
// begin
//   FDetalles := AValue;
//   EnlazarMaestroDetalle(FDetallesLink, FDetalles);
// end;

constructor TBizIBizBanca.Create(aDataTable: TDADataTable);
begin
  inherited;
  // Descomentar esto si hay clases detalles
  // FDetallesLink := TDADataSource.Create(NIL);
  // FDetallesLink.DataTable := aDataTable;  
  
	FSeleccionableInterface := TSeleccionable.Create(aDataTable);  
end;

destructor TBizIBizBanca.Destroy;
begin
	// Descomentar esto si hay clases detalles
  // FDetalles := NIL;
  // FreeAndNIL(FDetallesLink);	
  
  FSeleccionableInterface := NIL;
  inherited;
end;

function TBizIBizBanca.EsNuevo: Boolean;
begin
  Result := (ID < 0);
end;

procedure TBizIBizBanca.IniciarValoresIBizBancaNuevo;
begin
  //
end;

procedure TBizIBizBanca.OnNewRecord(Sender: TDADataTable);
begin
  inherited;
  ID := GetRecNo; // -1, -2, -3...
  IniciarValoresIBizBancaNuevo;
end;

initialization
  RegisterDataTableRules(BIZ_CLIENT_IBIZBANCA, TBizIBizBanca);

finalization

end.

